/*
        Thymio-II Firmware

        Copyright (C) 2011 Philippe Retornaz <philippe dot retornaz at epfl dot ch>,
        Mobots group (http://mobots.epfl.ch), Robotics system laboratory (http://lsro.epfl.ch)
        EPFL Ecole polytechnique federale de Lausanne (http://www.epfl.ch)

        See authors.txt for more details about other contributors.

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU Lesser General Public License as published
        by the Free Software Foundation, version 3 of the License.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public License
        along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

.include "p24fxxxx.inc"

.text
.section .entrypoint,code
.global _entrypoint
_entrypoint:
; Reset the stack
	mov #__SP_init, w15
;	mov #__SPLIM_init, w0
;	mov w0, SPLIM

	;; Hack, we need to init these variables 
	;; before enabling usb�
	mov #_status, w0
	clr [w0]
	mov #_usb_ptr, w0
	clr [w0]

	
	;; Switch to ALTIVT
	bset INTCON2, #15
	
	;; Enable USB Interrupt
	bset IEC5, #6
	
	;; jump to C entry point
	clr w0
	bra _bootloader_loop



.global _goto_userspace
.section .exit,code
_goto_userspace:
	clr TBLPAG
	mov #0x200, w0
	tblrdh [w0], w1
	cp0 w1
	bra z,out_nocode
	mov #0xff, w0 ; interpreted as "NOP" should not be at 0x200
	sub w0,w1,w0
	bra z,out_nocode
	
	;; Disable USB interrupt
	bclr IEC5, #6
	
	;; Switch back to standard interrupt table
	bclr INTCON2, #15
	
	;; Jump to user code entry point
	goto 0x204
	
out_nocode:
	reset
